package cn.estsh.i3plus.core.apiservice.controller.base;

import cn.estsh.i3plus.core.api.iservice.base.ISynchronizedService;
import cn.estsh.i3plus.core.api.iservice.base.ISystemInitService;
import cn.estsh.i3plus.core.api.iservice.base.ISystemLoginStrategyService;
import cn.estsh.i3plus.core.api.iservice.busi.*;
import cn.estsh.i3plus.core.apiservice.controller.busi.*;
import cn.estsh.i3plus.core.apiservice.util.MailUtil;
import cn.estsh.i3plus.core.apiservice.util.SysUserPasswordUtil;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.platform.common.tool.JsonUtilTool;
import cn.estsh.i3plus.platform.common.tool.ServletRequestTool;
import cn.estsh.i3plus.platform.common.tool.StringTool;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.platform.common.util.PlatformConstWords;
import cn.estsh.i3plus.pojo.base.annotation.AnnoIgnoreLog;
import cn.estsh.i3plus.pojo.base.bean.BaseConstWords;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.base.bean.BaseThreadLocal;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.model.common.CloudPagerModel;
import cn.estsh.i3plus.pojo.model.common.ImppEmail;
import cn.estsh.i3plus.pojo.model.common.ImppSmsContent;
import cn.estsh.i3plus.pojo.model.common.UserModel;
import cn.estsh.i3plus.pojo.model.license.ImppLicense;
import cn.estsh.i3plus.pojo.model.platform.*;
import cn.estsh.i3plus.pojo.platform.bean.*;
import cn.estsh.i3plus.sdk.dingtalk.dingrobot.DingRobotRequestBody;
import cn.estsh.i3plus.sdk.dingtalk.service.IDingTalkService;
import cn.estsh.impp.framework.base.controller.CoreBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.license.ImppLicenseTool;
import cn.estsh.impp.framework.boot.license.serviceimpl.ImppLicenseDecoder;
import cn.estsh.impp.framework.boot.util.*;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.ParserConfig;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.aliyun.dingtalkoauth2_1_0.models.GetAccessTokenRequest;
import com.aliyun.dingtalkoauth2_1_0.models.GetAccessTokenResponse;
import com.aliyun.dingtalkrobot_1_0.models.BatchSendOTOHeaders;
import com.aliyun.dingtalkrobot_1_0.models.BatchSendOTORequest;
import com.aliyun.dingtalkrobot_1_0.models.BatchSendOTOResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teaopenapi.models.Config;
import com.aliyun.teautil.models.RuntimeOptions;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiV2UserGetbymobileRequest;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.dingtalk.api.response.OapiV2UserGetbymobileResponse;
import com.google.common.cache.Cache;
import com.google.common.cache.CacheBuilder;
import com.taobao.api.ApiException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import jodd.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authc.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.function.BiFunction;
import java.util.stream.Collectors;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2018-12-19 15:31
 * @Modify:
 **/
@RestController
@Api(tags = "非权限服务")
@RequestMapping("/impp/white")
public class WhiteController extends CoreBaseController {

    public static final Logger LOGGER = LoggerFactory.getLogger(WhiteController.class);

    @Autowired
    private PersonnelController personnelController;

    @Autowired
    private SysUserInfoController sysUserInfoController;

    @Autowired
    private ISysUserService sysUserService;

    @Autowired
    private ISysLocaleLanguageService sysLocaleLanguageService;

    @Autowired
    private ISysLocaleResourceService sysLocaleResourceService;

    @Autowired
    private ISysUserService userService;

    @Autowired
    private IPersonnelService personnelService;

    @Autowired
    private ISystemInitService systemInitService;

    @Autowired
    private ISysFileService sysFileService;

    @Autowired
    private ISysDictionaryService dictionaryService;

    @Autowired
    private ISynchronizedService synchronizedService;

    @Autowired
    private ISysOrganizeService sysOrganizeService;

    @Autowired
    private ISysLabelTemplateService sysLabelTemplateService;

    @Autowired
    private ISysConfigService configService;

    @Autowired
    private ISysUserPasswordService userPasswordService;

    @Autowired
    private SysUserPasswordUtil userPasswordUtil;

    @Resource(name = CommonConstWords.IMPP_REDIS_RES)
    private ImppRedis redisRes;

    @Autowired
    private ILicenseClickService licenseClickService;

    @Resource(name = CommonConstWords.IMPP_REDIS_SESSION)
    private ImppRedis redisSession;

    @Autowired
    private RabbitTemplate rabbitTemplate;

    @Autowired
    private IDingTalkService dingTalkService;

    @Autowired
    private SysSmsSendRecordController smsSendRecordController;

    @Autowired
    private ISysRoleService sysRoleService;

    @Autowired
    private SysUserController sysUserController;

    @Autowired
    private SysFileController sysFileController;

    private Cache<String, Integer> unsavedLocaleResSwitch = CacheBuilder.newBuilder()
            .maximumSize(1)
            .expireAfterWrite(1, TimeUnit.MINUTES)
            .build();

    @GetMapping(value = "/sys-locale-language/list")
    @ApiOperation(value = "查询可用语言", notes = "查询可用语言")
    public ResultBean listSysLocaleLanguage() {
        try {
            List sysLocaleLanguageList = sysLocaleLanguageService.findSysLocaleLanguageByStatus(CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(sysLocaleLanguageList);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping(value = "/system-info")
    @ApiOperation(value = "查询可用语言", notes = "查询可用语言")
    public ResultBean getSystemInfo() {
        try {
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(configService.findSystemInfoConfig());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping(value = "/session-user")
    @ApiOperation(value = "获取用户信息", notes = "获取当前登录用户账号详细信息")
    public ResultBean getSession() {
        LOGGER.info("获取用户信息...lang:{}", AuthUtil.getSessionAttribute("languageCode"));
        try {
            SessionUser sUser = AuthUtil.getSessionUser();
            LOGGER.info("用户：{}", sUser);
            return new ResultBean(true, "", sUser);
        } catch (ImppBusiException e) {
            return new ResultBean(false, e.getErrorDetail() + "-[解决]" + e.getErrorSolution());
        }
    }

    /**
     * @return
     */
    @GetMapping(value = "/auth/logout")
    @ApiOperation(value = "登出", notes = "登出")
    public ResultBean logout() {
        LOGGER.info("用户退出...");
        try {
            AuthUtil.logout();
            return new ResultBean(true, "您已安全退出。").build();
        } catch (ImppBusiException e) {
            return new ResultBean(false, e.getErrorDetail() + "-[解决]" + e.getErrorSolution());
        }
    }

    @GetMapping(value = "/auth/set-cookie")
    @ApiOperation(value = "设置cookie", notes = "设置cookie")
    public ResultBean setCookie(String token, String imppcookie) {
        try {
            return new ResultBean(true, AuthUtil.getSessionUser().getUserName() + "设置cookie完成。").build();
        } catch (ImppBusiException e) {
            return new ResultBean(false, e.getErrorDetail() + "-[解决]" + e.getErrorSolution());
        }
    }

    @GetMapping(value = "/auth/{loginStrategy}/sso-login")
    @ApiOperation(value = "登录", notes = "登录")
    public ResultBean ssoLogin(HttpServletRequest request, HttpServletResponse response,
                               @PathVariable(name = "loginStrategy") String loginStrategy) throws NoSuchFieldException {
        String fieldMapping = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.SSO_REQUEST_MAPPING);
        if (StringUtils.isEmpty(fieldMapping)) {
            return ResultBean.fail("请在平台数据库中配置表添加字段映射配置");
        }

        SysLoginModel loginModel = assembleLoginModelByRequest(request, fieldMapping);
        loginModel.setLoginStrategy(loginStrategy);
        LOGGER.info("loginModel {}", loginModel);

        ValidatorBean.beginValid(loginModel)
                .notNull("loginStrategy", loginModel.getLoginStrategy())
                .notNull("loginName", loginModel.getLoginName());

        String ssoCacheKey = assembleSsoCacheKey(loginModel);
        Object loginCacheObject = redisSession.getObject(ssoCacheKey);
        if (loginCacheObject != null) {
            LOGGER.info("使用原会话 获取缓存不为空");
            SessionUser sessionUser = (SessionUser) redisSession.getObject(loginCacheObject);
            if (sessionUser != null) {
                LOGGER.info("使用原会话 sessionUser不为空");
                if (sessionUser.getUserCode().equals(loginModel.getLoginName()) || sessionUser.getUserName().equals(loginModel.getLoginName())) {
//                    AuthUtil.setSessionUser(sessionUser);
                    LOGGER.info("使用原会话 用户名匹配返回");
                    return new ResultBean(true, sessionUser.getToken(), sessionUser);
                }
            }
        }

        String beanName = ImppEnumUtil.AUTH_LOGIN_STRATEGY.codeOfStrategyName(loginModel.getLoginStrategy());
        ISystemLoginStrategyService loginStrategyService = (ISystemLoginStrategyService) SpringContextsUtil.getBean(beanName);

        BaseThreadLocal.setData(PlatformConstWords.IS_SSO_LOGIN, true);

        ResultBean<SessionUser> resultBean = loginByStrategy(request, loginModel, loginStrategyService.login());
        if (resultBean.isSuccess()) {
            String loginFilterKey = assembleLoginFilterKey(loginModel, resultBean);
            redisSession.putObject(ssoCacheKey, loginFilterKey);
            LOGGER.info("使用新会话 放入缓存 key:{} value:{}", ssoCacheKey, loginFilterKey);
            LOGGER.info("使用新会话 sessionUser:{}", resultBean.getResultObject());
        }
        return resultBean;
    }

    private String assembleLoginFilterKey(SysLoginModel loginModel, ResultBean<SessionUser> resultBean) {
        return CommonConstWords.SESSION_USER + ":" + loginModel.getLoginPlatform() + "_" + resultBean.getResultObject().getUserId();
    }

    private String assembleSsoCacheKey(SysLoginModel loginModel) {
        return CommonConstWords.SESSION_USER + ":" + loginModel.getLoginStrategy() + ":" + loginModel.getLoginName();
    }

    private SysLoginModel assembleLoginModelByRequest(HttpServletRequest request, String fieldMapping) {
        JSONObject mappingObject = (JSONObject) JSONObject.parse(fieldMapping);

        SysLoginModel loginModel = new SysLoginModel();
        getJsonObjectParameterFromRequest("loginName", request, mappingObject).ifPresent(d -> loginModel.setLoginName(d.toString()));
        getJsonObjectParameterFromRequest("loginPwd", request, mappingObject).ifPresent(d -> loginModel.setLoginPwd(d.toString()));
        getJsonObjectParameterFromRequest("appId", request, mappingObject).ifPresent(d -> loginModel.setAppId(d.toString()));
        getJsonObjectParameterFromRequest("languageCode", request, mappingObject).ifPresent(d -> loginModel.setLanguageCode(d.toString()));
        getJsonObjectParameterFromRequest("deviceId", request, mappingObject).ifPresent(d -> loginModel.setDeviceId(d.toString()));

        return loginModel;
    }

    private Optional<Object> getJsonObjectParameterFromRequest(String key, HttpServletRequest request, JSONObject mappingObject) {
        Object data = request.getParameter(mappingObject.get(key) == null ? "" : mappingObject.get(key).toString());
        return Optional.ofNullable(data);
    }

    @GetMapping(value = "/auth/dingtalk/auth")
    @ApiOperation(value = "鉴权", notes = "鉴权")
    public ResultBean authByPhoneNumber(@RequestParam String authCode) {
        SysUser user = null;
        List<SysMenu> menuList;
        try {
            OapiV2UserGetResponse dingTalkUserInfo = getDingTalkUserInfo(authCode);

            String mobile = dingTalkUserInfo.getResult().getMobile();
            if (StringUtils.isEmpty(mobile)) {
                return ResultBean.fail("用户并未在钉钉中设置手机号 或 钉钉接口权限不足无法获取到手机号");
            }
            user = userService.getSysUserByPhone(mobile);
            if (user == null) {
                return ResultBean.fail("未根据用户手机在平台中找到相应记录 钉钉获取的手机号为" + mobile);
            }
            userService.packUser(user);
            menuList = user.getMenuList();
        } catch (Exception e) {
            LOGGER.error("用户鉴权失败:{},e:{}", user, e.getMessage());
            return ResultBean.fail("对指定手机号允许,权限不足,请联系管理员");
        }
        return ResultBean.success("查询成功").setResultList(menuList);

    }

    @GetMapping(value = "/auth/dingtalk/login")
    @ApiOperation(value = "登录", notes = "登录")
    public ResultBean loginByPhoneNumber(HttpServletRequest request, String dingTalkTmpAuthCode,
                                         @RequestParam(required = false) String languageCode,
                                         @RequestParam(required = false) String deviceId) {
        SysLoginModel loginModel = SysLoginModel.builder()
                .dingTalkTmpAuthCode(dingTalkTmpAuthCode)
                .languageCode(languageCode)
                .deviceId(deviceId)
                .loginStrategy(ImppEnumUtil.AUTH_LOGIN_STRATEGY.NAME.getCode()).build();

        String dingTalkUrl = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_URL);
        String dingTalkAppKey = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_KEY);
        String dingTalkAppSecret = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_SECRET);
        String dingTalkWhiteList = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_WHITE_LIST);

        if (StringUtils.isEmpty(dingTalkUrl) ||
                StringUtils.isEmpty(dingTalkAppKey) ||
                StringUtils.isEmpty(dingTalkAppSecret) ||
                StringUtils.isEmpty(dingTalkWhiteList)) {
            return ResultBean.fail("访问钉钉的系统参数缺失，请在平台的系统参数中进行配置");
        }

        Optional<OapiV2UserGetResponse> userInfo =
                dingTalkService.getUserInfo(dingTalkUrl, dingTalkAppKey, dingTalkAppSecret, loginModel.getDingTalkTmpAuthCode());
        if (userInfo.isPresent()) {
            String mobile = userInfo.get().getResult().getMobile();
            if (StringUtils.isEmpty(mobile)) {
                return ResultBean.fail("用户并未在钉钉中设置手机号 或 钉钉接口权限不足无法获取到手机号");
            }
            if (!Arrays.asList(dingTalkWhiteList.split(",")).contains(mobile)) {
                return ResultBean.fail("对指定手机号允许,权限不足,请联系管理员");
            }
            SysUser sysUserByPhone = userService.getSysUserByPhone(mobile);
            if (sysUserByPhone == null) {
                return ResultBean.fail("未根据用户手机在平台中找到相应记录 钉钉获取的手机号为" + mobile);
            }
            loginModel.setLoginName(sysUserByPhone.getUserLoginName());
            loginModel.setPhoneNumber(mobile);
        } else {
            return ResultBean.fail("获取钉钉用户信息失败");
        }
        String beanName = ImppEnumUtil.AUTH_LOGIN_STRATEGY.codeOfStrategyName(loginModel.getLoginStrategy());
        ISystemLoginStrategyService loginStrategyService = (ISystemLoginStrategyService) SpringContextsUtil.getBean(beanName);

        return loginByStrategy(request, loginModel, loginStrategyService.login());
    }

    @GetMapping(value = "/auth/login")
    @ApiOperation(value = "登录", notes = "登录")
    public ResultBean login(HttpServletRequest request, String loginName, String loginPwd,
                            @RequestParam(required = false) String languageCode,
                            @RequestParam(required = false) String deviceId) {
        SysLoginModel loginModel = SysLoginModel.builder()
                .loginName(loginName)
                .loginPwd(loginPwd)
                .languageCode(languageCode)
                .deviceId(deviceId)
                .loginStrategy(ImppEnumUtil.AUTH_LOGIN_STRATEGY.ACCOUNT.getCode()).build();
        String beanName = ImppEnumUtil.AUTH_LOGIN_STRATEGY.codeOfStrategyName(loginModel.getLoginStrategy());
        ISystemLoginStrategyService loginStrategyService = (ISystemLoginStrategyService) SpringContextsUtil.getBean(beanName);

        return loginByStrategy(request, loginModel, loginStrategyService.login());
    }


    private ResultBean loginByStrategy(HttpServletRequest request, SysLoginModel loginModel, BiFunction<HttpServletRequest, SysLoginModel, ResultBean> loginStrategy) {
        long startTime = System.currentTimeMillis();
        licenseClickService.checkLicenseNumberLogin();

        LOGGER.info("用户登陆 loginName:{} loginPwd:{} languageCode:{}", loginModel.getLoginName(), loginModel.getLoginPwd(), loginModel.getLanguageCode());
        ResultBean result = null;
        CommonEnumUtil.USER_LOGIN_STATUS userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.LOGIN_SUCCESS;

        try {
            result = loginStrategy.apply(request, loginModel);
        } catch (IncorrectCredentialsException e) {
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_USER_PASSWORD);
            userPasswordUtil.checkLoginErrorNumber(loginModel.getLoginName(), result, e);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.WRONG_PASSWORD;
        } catch (ExpiredCredentialsException e) {
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_PASSWORD_EXPIRED);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.WRONG_USERNAME_OR_PASSWORD;
        } catch (CredentialsException e) {
            // 用户名或密码错误
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_USER_NAME);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.WRONG_USERNAME_OR_PASSWORD;
        } catch (LockedAccountException e) {
            // 账号已锁定
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_USER_LOCKING);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.USER_LOGIN_LOCKING;
        } catch (UnknownAccountException e) {
            // 用户信息不存在
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_USER_INFO_NULL);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.USER_INFO_NULL;
        } catch (AuthenticationException e) {
            // 系统异常
            result = ResultBean.fail(ImppExceptionEnum.LOGIN_EXCEPTION_USER_PASSWORD.getDescription()).setCode(ImppExceptionEnum.LOGIN_EXCEPTION_USER_PASSWORD.getCode());
            if (e.getCause() != null) {
                if (e.getCause() instanceof ImppBusiException) {
                    ImppBusiException imppBusiException = (ImppBusiException) e.getCause();
                    result.setErrorMsg(LocaleUtils.getLocaleRes(imppBusiException.getErrorDetail()));
                } else {
                    result.setErrorMsg(e.getCause().getMessage());
                }
            } else {
                result.setErrorMsg(e.getMessage());
            }
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.SYSTEM_ERROR;
            LOGGER.warn("Impp业务异常AuthenticationException 登录失败 ", e);
        } catch (ImppBusiException e) {
            result = ResultBean.fail(e);
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.SYSTEM_ERROR;
            LOGGER.warn("Impp业务异常ImppBusiException 登录失败 ", e);
        } catch (Exception e) {
            result = ResultBean.fail(e.getMessage()).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode())
                    .setErrorMsg(LocaleUtils.getEnumLocaleResDesc(ImppExceptionEnum.SYSTEM_EXCEPTION, ImppExceptionEnum.SYSTEM_EXCEPTION.getDescription()));
            userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.SYSTEM_ERROR;
            LOGGER.warn("Impp业务异常Exception 登录失败 ", e);
        } finally {
            if (result != null && !result.isSuccess()) {
                if (CommonEnumUtil.USER_LOGIN_STATUS.LOGIN_SUCCESS.getValue() == userLoginStatus.getValue()) {
                    userLoginStatus = CommonEnumUtil.USER_LOGIN_STATUS.SYSTEM_ERROR;
                }
            }
            // 记录登录记录
            recordSysUserLog(null, loginModel.getLoginName(), userLoginStatus.getValue());
        }

        LOGGER.info("会员{}登陆登录完成,登录{},语言：{} , 登录耗时:{}", loginModel.getLoginName(), result.isSuccess() ? "成功" : "失败", BaseThreadLocal.getThreadLanguageCode(), (System.currentTimeMillis() - startTime));
        return result;
    }

    private void recordSysUserLog(Long userId, String username, Integer userLoginStatus) {
        SysLogUserLogin log = new SysLogUserLogin();

        log.setUserId(userId);
        log.setLogLoginName(username);
        log.setLogLoginStatus(userLoginStatus);
        log.setLogLoginBrowser(ServletRequestTool.getRequestBrowser(request));
        log.setLogLoginHost(ServletRequestTool.getRequestHost(request));
        log.setLogLoginPlatform(CommonEnumUtil.LOG_LOGIN_PLATFORM.descOf(ServletRequestTool.getRequestOs(request)));
        log.setLogLoginDateTime(TimeTool.getNowTime(true));

        userService.insertSysLogUserLogin(log);
    }

    @GetMapping(value = "/find-language-code")
    @ApiOperation(value = "根据语言代码查询资源")
    public ResultBean findSysLocaleResourceByLanguageCode(String languageCode) {
        try {
            startMultiService();

            ValidatorBean.checkNotNull(languageCode, "语言代码不能为空");
            if (sysLocaleLanguageService.getSysLocaleLanguageByCode(languageCode) == null) {
                throw ImppExceptionBuilder.newInstance()
                        .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
                        .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                        .setErrorDetail("语言不存在")
                        .build();
            }

            // 从缓存获取语言信息
            Map<Object, Object> resourceMap =
                    redisRes.getHashMap(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode);
            if (resourceMap == null || resourceMap.size() == 0) {
                systemInitService.putAndLoadSysLocaleLanguage();
                resourceMap = redisRes.getHashMap(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode);
            }

            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultMap(resourceMap);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


    /**
     * 获取首页所需要的翻译资源
     * 目前只有三个
     *
     * @param languageCode
     * @return
     */
    @GetMapping(value = "/find-indexpage-language-resource")
    @ApiOperation(value = "获取首页所需的翻译资源")
    public ResultBean findInexPageResourceByLanguageCode(String languageCode) {
        try {

            ValidatorBean.checkNotNull(languageCode, "语言代码不能为空");
            if (sysLocaleLanguageService.getSysLocaleLanguageByCode(languageCode) == null) {
                throw ImppExceptionBuilder.newInstance()
                        .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
                        .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                        .setErrorDetail("语言不存在")
                        .build();
            }
            Map<String, Object> indexMap = new HashMap<>();
            indexMap.put("记住密码", redisRes.getHash(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":1", "记住密码"));
            indexMap.put("自动登录", redisRes.getHash(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":1", "自动登录"));
            indexMap.put("登录", redisRes.getHash(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":1", "登录"));
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultMap(indexMap);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/sys-locale-resource/query")
    @ApiOperation(value = "按条件查询资源")
    public ResultBean findSysLocaleResource(@RequestBody CloudPagerModel<SysLocaleResource> pagerModel) {
        try {
            ListPager<SysLocaleResource> resourceList = sysLocaleResourceService.querySysLocaleResourceByPager(
                    pagerModel.getObj(), pagerModel.getPager()
            );
            return ResultBean.success("操作成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setListPager(resourceList);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/find-resource")
    @ApiOperation(value = "按条件查询资源")
    public ResultBean<SysLocaleResource> findSysLocaleResource(@RequestBody SysLocaleResource resource) {
        try {
            startMultiService();

            List<SysLocaleResource> resourceList = sysLocaleResourceService.findSysLocaleResource(resource);

            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(resourceList);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


    @GetMapping(value = "/find-language-code-soft-type")
    @ApiOperation(value = "根据语言代码查询资源")
    public ResultBean findSysLocaleResourceByLanguageCode(String languageCode, Integer softType,
                                                          @RequestParam(defaultValue = "2") Integer needPlatformRes) {
        try {
            startMultiService();

            ValidatorBean.checkNotNull(languageCode, "语言代码不能为空");
            ValidatorBean.checkNotNull(softType, "软件类型不能为空");
            if (sysLocaleLanguageService.getSysLocaleLanguageByCode(languageCode) == null) {
                throw ImppExceptionBuilder.newInstance()
                        .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
                        .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                        .setErrorDetail("语言不存在")
                        .build();
            }

            // 从缓存获取语言信息
            Map<Object, Object> resourceMap =
                    redisRes.getHashMap(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":" + softType);
            if (resourceMap == null || resourceMap.size() == 0) {
                systemInitService.putAndLoadSysLocaleLanguage();
                resourceMap = redisRes.getHashMap(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":" + softType);
            }

            if (needPlatformRes.intValue() == CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue()) {
                Map<Object, Object> platformResMap =
                        redisRes.getHashMap(CommonConstWords.REDIS_PREFIX_CACHE_LANGUAGE_WEB + ":" + languageCode + ":" + CommonEnumUtil.SOFT_TYPE.IMPP.getValue());
                ;
                resourceMap.putAll(platformResMap);
            }

            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultMap(resourceMap);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


    @PostMapping(value = "/sys-file/insert")
    @ApiOperation(value = "新增文件资源", notes = "新增文件资源")
    public ResultBean insertSysFile(@RequestBody SysFile sysFile) {
        try {
            startMultiService();

            // 条件验证
            ValidatorBean.beginValid(sysFile)
                    .notNull("dfsFileName", sysFile.getDfsFileName())
                    .notNull("dfsGroupName", sysFile.getDfsGroupName())
                    .notNull("fileSoftType", sysFile.getFileSoftType())
                    .notNull("fileOriginalName", sysFile.getFileOriginalName());

            // 文件类型验证
            SysDictionary dictionary = dictionaryService.getSysDictionaryByParentCodeAndValue(BaseConstWords.DICTIONARY_FILE_TYPE,
                    StringTool.getStringFileSuffix(sysFile.getFileOriginalName(), true));
            if (dictionary == null) {
                throw ImppExceptionBuilder.newInstance()
                        .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
                        .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION_FORMAT.getCode())
                        .setErrorDetail("文件格式不支持 %s", sysFile.getFileOriginalName())
                        .setErrorSolution("请到字典管理中添加文件类型")
                        .build();
            }

            // 初始化数据
            sysFile.setFileTypeId(dictionary.getId());
            sysFile.setFileTypeName(dictionary.getName());

            ConvertBean.serviceModelInitialize(sysFile, "白名单");

            sysFile = sysFileService.insertSysFile(sysFile);
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultObject(sysFile);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 根据id删除文件资源
     *
     * @param idStr 文件资源
     * @return 处理结果
     */
    @DeleteMapping(value = "/sys-file/delete/{id}")
    @ApiOperation(value = "根据id删除文件资源", notes = "根据id删除文件资源")
    public ResultBean deleteSysFileById(@PathVariable("id") String idStr) {
        return sysFileController.deleteSysFileById(idStr);
    }

    /**
     * 根据文件代码查询文件信息
     *
     * @param fileCode 文件代码
     * @return 处理结果
     */
    @GetMapping("/sys-file/get-file-code/{code}")
    @ApiOperation(value = "根据文件代码查询文件信息")
    public ResultBean getSysFileByFileCode(@PathVariable("code") String fileCode) {
        try {
            // 条件验证
            ValidatorBean.checkNotNull(fileCode, "文件代码不能为空");
            SysFile sysFile = sysFileService.getSysFileByFileCode(fileCode);

            return ResultBean.success().setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultObject(sysFile);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


    @GetMapping(value = "/sys-order-no-rule/get-order-no/{code}")
    @ApiOperation(value = "根据单号规则代码，生成单号")
    public ResultBean getOrderNo(@PathVariable("code") String code) {
        try {
            ValidatorBean.checkNotNull(code, "code不能为空");

            SysOrderNoRule sysOrderNoRule = synchronizedService.nextOrderNo(code);
            return ResultBean.success("操作成功").setResultObject(sysOrderNoRule).setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 根据单号规则代码，生成单号
     *
     * @param code 单号规则代码
     * @param num  生成数量
     * @return 处理结果
     */
    @GetMapping(value = "/sys-order-no-rule/get-order-no/{code}/{num}")
    @ApiOperation(value = "根据单号规则代码，生成单号")
    public ResultBean<String> getOrderNo(@PathVariable("code") String code, @PathVariable("num") Integer num) {
        try {
            ValidatorBean.checkNotNull(code, "code不能为空");
            ValidatorBean.checkNotZero(num, "次数不能为零");

            List<String> orderNoList = synchronizedService.nextOrderNo(code, num).stream().map(SysOrderNoRule::getOrderNo).collect(Collectors.toList());
            return ResultBean.success("操作成功").setResultList(orderNoList).setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/sys-find-user/list")
    @ApiOperation(value = "查询用户列表信息", notes = "查询用户列表信息")
    public ResultBean findSysUserInfoList(UserDetailModel model) {
        try {
            List<SysUser> userList = personnelService.querySysUserByUserDetailModelOrIds(model, new ArrayList<>());
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(userList);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * @return 处理结果
     */
    @GetMapping("/sys-login-platform")
    @ApiOperation(value = "登录标识", notes = "登录标识")
    public ResultBean getSysloginPlatforml() {
        return new ResultBean(true, "操作成功",
                Arrays.asList(CommonEnumUtil.LOG_LOGIN_PLATFORM.values()));
    }

    @GetMapping("/sys-auth-platform")
    @ApiOperation(value = "登录授权标识", notes = "登录授权标识")
    public ResultBean getAuthPlatform() {
        return new ResultBean(true, "操作成功",
                Arrays.asList(CommonEnumUtil.AUTH_PLATFORM.values()));
    }

    @GetMapping("/sys-organize/list")
    @ApiOperation(value = "获取全部组织", notes = "获取全部组织")
    public ResultBean<SysOrganize> findSysOrganizeList() {
        try {
            List<SysOrganize> sysOrganizeList = sysOrganizeService.findAll();
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(sysOrganizeList);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 查询全部打印模板
     *
     * @return 处理结果
     */
    @PostMapping(value = "/sys-label-template/list")
    @ApiOperation(value = "查询全部打印模板", notes = "查询全部打印模板")
    public ResultBean<SysLabelTemplate> findSysConfigAll(@RequestBody SysLabelTemplate template) {
        try {
            List<SysLabelTemplate> sysLabelTemplateList = sysLabelTemplateService.listSysLabelTemplateDetail(template);
            ;
            return ResultBean.success("操作成功")
                    .setResultList(sysLabelTemplateList)
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 查询未翻译的资源
     *
     * @return 处理结果
     */
    @PostMapping(value = "/locale-resource/no-resource")
    @ApiOperation(value = "查询未翻译的资源", notes = "查询未翻译的资源")
    public ResultBean<SysLabelTemplate> findSysConfigAll() {
        try {
            Set<String> keys = redisRes.getKeysSet(CommonConstWords.REDIS_PREFIX_CACHE_NO_RES + "*");
            List<String> list = new ArrayList<>();
            for (String key : keys) {
                list.add(redisRes.getObject(key).toString());
            }
            return ResultBean.success("操作成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultList(list);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 根据条件分页查询用户信息
     *
     * @param model 查询条件
     * @return 处理结果
     */
    @PostMapping(value = "/personnel/pager/get-user-list")
    @ApiOperation(value = "根据条件分页查询账号信息", notes = "根据条件分页查询账号信息")
    public ResultBean queryPagerByUser(@RequestBody UserDetailPagerModel model) {
        try {
            ListPager<SysUser> listPager = personnelService.querySysUser(model.getUserDetailModel(), model.getPager());
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setListPager(listPager);
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ResultBean.fail(e).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode());
        }
    }

    /**
     * 缺失资源
     *
     * @param key
     * @param menuCode
     * @return
     */
    @AnnoIgnoreLog
    @PostMapping(value = "/miss-resource/get")
    @ApiOperation(value = "缺失资源", notes = "缺失资源")
    public ResultBean getMissResourceByKey(String key, String menuCode) {
        try {
            Integer switcher = unsavedLocaleResSwitch.asMap().get(PlatformConstWords.WEB_MISS_RESOURCE_LISTENER_SWITCH);

            if (switcher == null) {
                switcher = RedisCacheTool.getSysConfigIntVal(PlatformConstWords.WEB_MISS_RESOURCE_LISTENER_SWITCH,
                        CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
                unsavedLocaleResSwitch.put(PlatformConstWords.WEB_MISS_RESOURCE_LISTENER_SWITCH, switcher);
            }
            if (switcher == -1 || switcher == CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue()) {
                return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
            }

            Map<String, String> missResource = new HashMap<>();
            missResource.put(key, menuCode);
            rabbitTemplate.convertAndSend(PlatformConstWords.QUEUE_IMPP_RESOURCE, JsonUtilTool.encode(missResource));
            return ResultBean.success("操作成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ResultBean.fail(e).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode());
        }
    }

    /**
     * 缺失资源开关
     *
     * @return
     */
    @AnnoIgnoreLog
    @GetMapping(value = "/miss-resource/web-listener-switch")
    @ApiOperation(value = "缺失资源开关", notes = "缺失资源开关")
    public ResultBean getWebMissResourceSwitch() {
        try {
            int webListener = RedisCacheTool.getSysConfigIntVal(PlatformConstWords.WEB_MISS_RESOURCE_LISTENER_SWITCH,
                    CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
            return ResultBean.success("获取成功")
                    .setResultObject(webListener == CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ResultBean.fail(e).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode());
        }
    }

    @PutMapping(value = "/update-expired-password")
    @ApiOperation(value = "修改密码", notes = "松下修改当前登录用户密码")
    public ResultBean updateSysUserPassword(String loginName, String password, String newPwd) {
        try {
            // 数据校验
            ValidatorBean.checkNotNull(password, "旧密码不能为空");
            ValidatorBean.checkNotNull(newPwd, "新密码不能为空");
            ValidatorBean.checkNotNull(loginName, "用户名不能为空");

            if (password.equals(newPwd)) {
                return ResultBean.fail("新旧密码不能相同");
            }

            userPasswordService.updatePasswordWizoutSession(loginName, password, newPwd.trim());
            return ResultBean.success("修改密码成功，请重新登陆").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/license")
    @ApiOperation(value = "更新授权", notes = "更新授权")
    public ResultBean updateLicense(String content) {
        try {
            ImppLicense license = ImppLicenseDecoder.getLicenseDecoder(content);
            if (Objects.nonNull(license)) {
                ImppLicenseTool.updateImppLicense(license);
            } else {
                return ResultBean.fail("错误的授权信息");
            }
            return ResultBean.success("操作成功");
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ResultBean.fail(e).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode());
        }
    }

    @GetMapping(value = "/forced-offline/{loginName}")
    @ApiOperation(value = "强制下线", notes = "强制下线")
    public ResultBean forcedOffline(@PathVariable("loginName") String loginName) {
        try {
            SysUser sysUser = userService.getSysUserByLoginName(loginName);
            ValidatorBean.checkNotNull(sysUser, "用户不存在，请检查【登录名】");
            redisSession.deleteBatchKey(CommonConstWords.SESSION_USER + ":*_" + sysUser.getId());
            return ResultBean.success("操作成功");
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ResultBean.fail(e).setCode(ImppExceptionEnum.SYSTEM_EXCEPTION.getCode());
        }
    }

    @GetMapping(value = "/send-test-mq")
    @ApiOperation(value = "测试发送mq", notes = "测试发送mq")
    public void sendTestMq(String paramStr) {
        rabbitTemplate.convertAndSend(PlatformConstWords.QUEUE_IMPP_DEMO, paramStr);
    }

    /********************************************SWEB所需接口*******************************************/
    /**
     * 添加用户信息
     *
     * @param model 用户信息
     * @return 处理结果
     */
    @PostMapping(value = "/user/insert")
    @ApiOperation(value = "添加用户信息", notes = "返回内容添加用户信息")
    public ResultBean insertUserDetailModel(@RequestBody UserDetailModel model) {
        //设置【密码】和【确认密码】一致
        model.setPassword(model.getUserLoginPassword());
        return personnelController.insertUserDetailModel(model);
    }

    /**
     * 修改用户信息
     *
     * @param model 用户信息
     * @return 处理结果
     */
    @PutMapping(value = "/user/update")
    @ApiOperation(value = "修改用户信息", notes = "返回内容添加用户信息")
    public ResultBean updateUserDetailModel(@RequestBody UserDetailModel model) {
        return personnelController.updateUserDetailModel(model);
    }

    /**
     * 删除用户信息
     *
     * @param id 用户id
     * @return 处理结果
     */
    @DeleteMapping(value = "/user/delete/{id}")
    @ApiOperation(value = "删除用户信息", notes = "根据用户信息id删除信息")
    public ResultBean deleteSysUserInfo(@PathVariable("id") String id) {
        return personnelController.deleteSysUserInfo(id);
    }

    /**
     * 查询用户信息
     *
     * @param cloudPagerModel 查询条件
     * @return 处理结果
     */
    @PostMapping(value = "/user/query")
    @ApiOperation(value = "查询用户信息", notes = "复杂查询用户信息带分页")
    public ResultBean querySysUserInfo(@RequestBody CloudPagerModel<SysUserInfo> cloudPagerModel) {
        return sysUserInfoController.querySysUserInfo(cloudPagerModel.getObj(), cloudPagerModel.getPager());
    }

    /**
     * 根据登录名，邮箱获取用户账号信息
     *
     * @param sysUser
     * @return
     */
    @PostMapping(value = "/user/query-user")
    @ApiOperation(value = "根据条件查询单个用户信息", notes = "根据条件查询单个用户信息")
    public ResultBean querySysUser(@RequestBody SysUser sysUser) {
        ValidatorBean.checkNotNull(sysUser.getUserLoginName(), "用户登录名不能为空!");
        ValidatorBean.checkNotNull(sysUser.getUserEmail(), "用户email不能为空!");
        SysUser user = null;
        try {
            user = sysUserService.getSysUserByLoginNameAndEmail(sysUser.getUserLoginName(), sysUser.getUserEmail());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e.getMessage());
        }
        return ResultBean.success("查询成功!").setResultObject(user);
    }

    @PostMapping(value = "/sendEmail")
    @ApiOperation(value = "无需登录,发送邮件")
    public ResultBean sendEmail(@RequestBody ImppEmail imppEmail) {
        ValidatorBean.checkNotNull(imppEmail.getContent(), "消息内容不能为空");
        ValidatorBean.checkNotNull(imppEmail.getEmail(), "email地址不能为空");
        try {
            MailUtil mailUtil = new MailUtil();
            mailUtil.init();
            mailUtil.setContentType(ImppEnumUtil.MESSAGE_TYPE_CONTENT.HTML.getDescription());
            mailUtil.setNick(imppEmail.getNick());
            mailUtil.setSubject(imppEmail.getSubject());
            mailUtil.setTo(imppEmail.getEmail());
            mailUtil.setBody(imppEmail.getContent());
            mailUtil.send();
        } catch (Exception e) {
            LOGGER.error("发送邮件:{}失败:{}", imppEmail.getEmail(), e.getMessage());
            return ResultBean.fail("发送失败,请检查邮箱是否输入正确!");
        }
        return ResultBean.success("验证码已发送!");
    }

    @PostMapping(value = "/update-vendor-pwd")
    @ApiOperation(value = "忘记密码")
    public ResultBean updateVendorPwd(@RequestBody UserModel userModel) {
        ValidatorBean.checkNotNull(userModel.getLoginName(), "登录名不能为空!");
        ValidatorBean.checkNotNull(userModel.getPassword(), "密码不能为空!");
        sysUserService.updateSysUserPwdByLoginName(userModel.getLoginName(), userModel.getPassword());
        return ResultBean.success("修改成功!");
    }

    @PostMapping("/sendSms")
    @ApiOperation("无需登录 发送短信")
    public ResultBean sendSms(@RequestBody ImppSmsContent imppSmsContent) {
        return smsSendRecordController.send(imppSmsContent);
    }


    @PostMapping(value = "/queryAllRoleRefUser")
    @ApiOperation(value = "在所有角色中查询角色及关联的人员信息", notes = "查询角色及关联的人员信息")
    public BaseResultBean queryAllRoleRefUser(@RequestBody SysRoleModel sysRoleModel) {
        try {
            ListPager result = null;
            List<SysRole> roleList = null;
            SysRole sysRole = sysRoleModel.getSysRole();
            Pager pager = sysRoleModel.getPager();
            if (ObjectUtils.isEmpty(sysRole)) {
                sysRole = new SysRole();
            }
            if (ObjectUtils.isEmpty(pager)) {
                pager = new Pager();
            }
            //过滤SysRefUserRole
            roleList = sysRoleService.findAllByRoleProperty(sysRole);
            if (ObjectUtils.isEmpty(roleList)) {
                return ResultBean.success("操作成功");
            }

            List<Long> roleIdList = roleList.stream().map(el -> el.getId()).collect(Collectors.toList());
            result = personnelService.findSysRefUserRoleByRoleIds(roleIdList, pager);
            return ResultBean.success("操作成功").setListPager(result).setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 根据登录的用户名批量修改账号状态
     *
     * @param userLoginNames 用户名数组
     * @param status         状态
     * @return 处理结果
     */
    @PutMapping(value = "/batch-status/userLoginNames")
    @ApiOperation(value = "根据用户名批量修改账号状态", notes = "根据用户名批量修改账号状态")
    public ResultBean updateBatchStatusByUserLoginNames(String[] userLoginNames, Integer status) {
        return sysUserController.updateBatchStatusByUserLoginNames(userLoginNames, status);
    }


    /**
     * 获取fastJosn配置并测试
     *
     * @return
     */
    @GetMapping(value = "/fastjson")
    @ApiOperation(value = "获取fastJosn配置", notes = "获取fastJosn配置")
    public ResultBean getFastJosnConfig() {
        ParserConfig config = ParserConfig.getGlobalInstance();
        SysUser model = new SysUser();

        model.setUserLoginName("test");
        Map<String, Object> resultMap = new HashMap<>();
        try {
            String json = JSON.toJSONString(model, SerializerFeature.WriteClassName);
            resultMap.put("json", json);
            JSON.parse(json);
            resultMap.put("parseredJosn", json);

            resultMap.put("config", JSON.toJSONString(config));
        } catch (Exception e) {
            e.printStackTrace();
            if (e.getCause() != null) {
                resultMap.put("error", e.getCause().getMessage());
            } else {
                resultMap.put("error", e.getMessage());
            }
        }
        return ResultBean.success().setResultMap(resultMap);
    }


    private static final Long ACCESS_TOKEN_EXPIRE_TIME = 7080L;
    private static final String ACCESS_TOKEN_KEY = "ding_talk:access_token";

    /**
     * 钉钉单聊机器人批量发送消息
     *
     * @param dingSendBatchRequestModel
     * @return
     */
    @PostMapping(value = "/dingRobot/sendBatchRequestByUserLoginName")
    @ApiOperation(value = "根据登录用户名 钉钉单聊机器人批量发送消息", notes = "根据登录用户名 钉钉单聊机器人批量发送消息")
    public ResultBean singleRobotsendBatchRequestByUserLoginName(@RequestBody DingSendBatchRequestModel dingSendBatchRequestModel) {
        if (ObjectUtils.isEmpty(dingSendBatchRequestModel)) {
            return ResultBean.fail("消息内容不能为空");
        }
        if (ObjectUtils.isEmpty(dingSendBatchRequestModel.getUserLoginNameList())) {
            return ResultBean.fail("登录用户名不能为空");
        }
        List<String> userLoginNameList = dingSendBatchRequestModel.getUserLoginNameList();
        userLoginNameList = userLoginNameList.stream().filter(StringUtils::isNotBlank).distinct().collect(Collectors.toList());
        if (ObjectUtils.isEmpty(userLoginNameList)) {
            return ResultBean.fail("登录用户名不能为空");
        }
        List<SysUser> userList = userService.findSysUserByLoginName(userLoginNameList);
        if (ObjectUtils.isEmpty(userList)) {
            return ResultBean.fail("登录用户名没有对应的账号");
        }
        List<String> phoneNumberList = userList.stream().map(SysUser::getUserPhone).filter(StringUtils::isNotBlank).distinct().collect(Collectors.toList());
        if (ObjectUtils.isEmpty(userList)) {
            return ResultBean.fail("登录用户名没有对应的手机号");
        }
        dingSendBatchRequestModel.setPhoneNumberList(phoneNumberList);
        return singleRobotsendBatchRequest(dingSendBatchRequestModel);

    }

    /**
     * 批量发送的最大值
     */
    private final int MAX_DINGROBOT_SEND_NUM = 1000;

    /**
     * 钉钉单聊机器人批量发送消息
     *
     * @param dingSendBatchRequestModel
     * @return
     */
    @PostMapping(value = "/dingRobot/sendBatchRequest")
    @ApiOperation(value = "根据手机号 钉钉单聊机器人批量发送消息", notes = "根据手机号 钉钉单聊机器人批量发送消息")
    public ResultBean singleRobotsendBatchRequest(@RequestBody DingSendBatchRequestModel dingSendBatchRequestModel) {
        if (ObjectUtils.isEmpty(dingSendBatchRequestModel)) {
            return ResultBean.fail("消息内容不能为空");
        }
        List<String> phoneNumberList = dingSendBatchRequestModel.getPhoneNumberList();
        String title = dingSendBatchRequestModel.getTitle();
        String content = dingSendBatchRequestModel.getContent();
        if (StringUtils.isBlank(content)) {
            return ResultBean.fail("消息内容不能为空");
        }
        if (ObjectUtils.isEmpty(phoneNumberList)) {
            return ResultBean.fail("手机号不能为空");
        }
        phoneNumberList = phoneNumberList.stream().filter(StringUtils::isNotBlank).distinct().collect(Collectors.toList());
        if (ObjectUtils.isEmpty(phoneNumberList)) {
            return ResultBean.fail("手机号不能为空");
        }
        Config config = new Config();
        config.protocol = "https";
        config.regionId = "central";
        com.aliyun.dingtalkrobot_1_0.Client client = null;
        try {
            client = new com.aliyun.dingtalkrobot_1_0.Client(config);
        } catch (Exception e) {
            e.printStackTrace();
            return ResultBean.fail(e).setMsg("发送失败");
        }
        BatchSendOTOHeaders batchSendOTOHeaders = new BatchSendOTOHeaders();
        batchSendOTOHeaders.xAcsDingtalkAccessToken = getAccessToken();
        BatchSendOTORequest batchSendOTORequest = new BatchSendOTORequest();
        List<String> userIdList = new ArrayList<String>();
        phoneNumberList.forEach(el -> {
            ResultBean result = getDingUserIdByPhoneNumber(el, batchSendOTOHeaders.xAcsDingtalkAccessToken);
            if (result.isSuccess()) {
                userIdList.add((String) result.getResultObject());
            } else {
                LOGGER.info("手机号:{}没法获取的钉钉用户id", el);
            }

        });
        if (userIdList.isEmpty()) {
            return ResultBean.fail("发送失败,无法根据手机号获取用户id");
        }
//        userIdList.add("27202755621041923");
//        userIdList.add("070537336424114523");

        String dingTalkAppKey = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_KEY);
        batchSendOTORequest.setRobotCode(dingTalkAppKey);
        batchSendOTORequest.setUserIds(userIdList);
        // markdown officialImageMsg
        DingRobotRequestBody requestBody = generateMarkdown(title, content);
        batchSendOTORequest.setMsgKey("sampleMarkdown");
        batchSendOTORequest.setMsgParam(JSON.toJSONString(requestBody.getMarkdown()));
        try {
            BatchSendOTOResponse response = client.batchSendOTOWithOptions(batchSendOTORequest, batchSendOTOHeaders, new RuntimeOptions());
            System.out.println(JSON.toJSONString(response));
        } catch (TeaException err) {
            err.printStackTrace();
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }
            return ResultBean.fail(err).setMsg("发送失败");

        } catch (Exception _err) {
            _err.printStackTrace();
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }
            return ResultBean.fail(err).setMsg("发送失败");
        }
        return ResultBean.success("发送成功");
    }

    private DingRobotRequestBody generateMarkdown(String title, String content) {
        DingRobotRequestBody dingRobotRequestBody = new DingRobotRequestBody();
        DingRobotRequestBody.MarkDown markDown = new DingRobotRequestBody.MarkDown();
        markDown.setTitle(title);
        dingRobotRequestBody.setMsgType("markdown");
//        markDown.setText(" # Andon 通知" +
//                "\n"+
//                "\n"+
//                " [![qGTEi6.png](https://s1.ax1x.com/2022/03/24/qGTEi6.png)](https://imgtu.com/i/qGTEi6) EP产线-01工位，物料缺料，请及时处理 "
//               );
//        markDown.setText(" # Andon 通知" +
//                "\n"+
//                "\n"+
//                " [![qGTEi6.png](https://s1.ax1x.com/2022/03/24/qGTEi6.png)](https://imgtu.com/i/qGTEi6) EP产线-01工位，物料缺料，请及时处理 "
//        );
//        markDown.setText(" ## Andon 通知" +
//                "\n"+
//                "\n"+
//                " [![qGTEi6.png](https://s1.ax1x.com/2022/03/24/qGTEi6.png)](https://imgtu.com/i/qGTEi6) EP产线-01工位，物料缺料，处理措施:联络供应商送货"
//        );
        markDown.setText(content);
        dingRobotRequestBody.setMarkDown(markDown);
        return dingRobotRequestBody;
    }

    /**
     * 根据手机号获取钉钉的uid
     *
     * @param phoneNumber
     * @return
     */
    public ResultBean getDingUserIdByPhoneNumber(String phoneNumber, String accessToken) {
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/user/getbymobile");
            OapiV2UserGetbymobileRequest req = new OapiV2UserGetbymobileRequest();
            req.setMobile(phoneNumber);
//            req.setMobile("13298408382");
            OapiV2UserGetbymobileResponse rsp = client.execute(req, accessToken);
            if (ObjectUtils.isEmpty(rsp) || ObjectUtils.isEmpty(rsp.getResult()) || StringUtils.isBlank(rsp.getResult().getUserid())) {
                return ResultBean.fail("根据手机号无法获取用户id");
            }
            return ResultBean.success("获取用户id成功").setResultObject(rsp.getResult().getUserid());
        } catch (ApiException e) {
            LOGGER.error("调用钉钉根据手机号获取用户id发生异常:", e);
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        } catch (Exception e) {
            LOGGER.error("调用钉钉根据手机号获取用户id发生异常:", e);
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    /**
     * 获取accessToken
     *
     * @return
     */
    private String getAccessToken() {
        Object accessTokenCached = redisCore.getObject(ACCESS_TOKEN_KEY);
        if (accessTokenCached != null) {
            return String.valueOf(accessTokenCached);
        }
        Config config = new Config();
        config.protocol = "https";
        config.regionId = "central";
        com.aliyun.dingtalkoauth2_1_0.Client client = null;
        String dingTalkAppKey = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_KEY);
        String dingTalkAppSecret = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_SECRET);
        try {
            client = new com.aliyun.dingtalkoauth2_1_0.Client(config);
        } catch (Exception e) {
            e.printStackTrace();
        }
        GetAccessTokenRequest getAccessTokenRequest = new GetAccessTokenRequest()
                .setAppKey(dingTalkAppKey)
                .setAppSecret(dingTalkAppSecret);
        try {
            GetAccessTokenResponse response = client.getAccessToken(getAccessTokenRequest);
            if (!StringUtils.isEmpty(response.body.accessToken)) {
                redisCore.putObject(ACCESS_TOKEN_KEY, response.body.accessToken, ACCESS_TOKEN_EXPIRE_TIME);
            }
            return response.body.accessToken;
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
        return "";
    }


    private OapiV2UserGetResponse getDingTalkUserInfo(String dingTalkTmpAuthCode) {
        String dingTalkUrl = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_URL);
        String dingTalkAppKey = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_KEY);
        String dingTalkAppSecret = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_APP_SECRET);
        String dingTalkWhiteList = RedisCacheTool.getSysConfigStrVal(PlatformConstWords.DINGTALK_WHITE_LIST);
        if (StringUtils.isEmpty(dingTalkUrl) ||
                StringUtils.isEmpty(dingTalkAppKey) ||
                StringUtils.isEmpty(dingTalkAppSecret) ||
                StringUtils.isEmpty(dingTalkWhiteList)) {
            throw ImppExceptionBuilder.newInstance().setErrorDetail("访问钉钉的系统参数缺失，请在平台的系统参数中进行配置").build();
        }

        Optional<OapiV2UserGetResponse> userInfo = dingTalkService.getUserInfo(dingTalkUrl, dingTalkAppKey, dingTalkAppSecret, dingTalkTmpAuthCode);
        if (!userInfo.isPresent()) {
            throw ImppExceptionBuilder.newInstance().setErrorDetail("访问钉钉的系统员工信息不存在").build();
        }
        return userInfo.get();
    }

    @GetMapping(value = "/query-user-by-name")
    @ApiOperation(value = "根据用户名或登录名查询")
    public ResultBean queryUserByName(String userLoginName, String userName, Pager pager) {
        try {
            if (ObjectUtils.isEmpty(pager)) {
                pager = Pager.defaultPager();
            }
            return ResultBean.success("操作成功").setListPager(sysUserService.findSysUserByName(userLoginName, userName, pager)).setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
